const fs = require('fs');
const path = require('path');
const CodeMirror = require('codemirror/addon/runmode/runmode.node');

const modes = require('../codemirror-modes/modes.json');

modes.forEach((mode) => {
  require(`codemirror/mode/${mode}/${mode}`); // eslint-disable-line import/no-dynamic-require, global-require
  const modeMimes = Object.keys(CodeMirror.mimeModes).map(mime => {
    const mimeMode = CodeMirror.mimeModes[mime];
    if (mimeMode === mode || mimeMode.name === mode) {
      return { mime, mimeMode };
    }
  }).filter(Boolean);

  modeMimes.forEach((modeMime) => {
    // console.log(modeMime);
    console.log(`CodeMirror.defineMIME(${modeMime.mime}, ${modeMime.mimeMode})`);
  });
  // CodeMirror.defineMode('${mode}', ${CodeMirror.modes[mode].toString()})

//   console.log(`
// // Auto-generated from build-codemirror-modes.js

// module.exports = function(CodeMirror) {

//   ${Object.keys(modeMimes).forEach(mime => {
//
//   })}
// }
// `);

//   fs.writeFileSync(path.join(__dirname, '../codemirror-modes/', `${mode}.js`), `
// // Auto-generated from build-codemirror-modes.js

// module.exports = ${CodeMirror.modes[mode].toString()}

// `);
});
